[Growth: 全栈增长工程师指南](https://github.com/phodal/growth-ebook)
===

Growth 纸质版《全栈应用开发：精益实践》，现已上市：

![全栈应用开发：精益实践](marketing/growth-paper.jpeg)

京东：[http://item.jd.com/12195442.html](http://item.jd.com/12195442.html)

当当：[http://product.dangdang.com/25077858.html](http://product.dangdang.com/25077858.html)

亚马逊：[https://www.amazon.cn/dp/B0722YJR89](https://www.amazon.cn/dp/B0722YJR89)

配合《[Growth: 全栈增长工程师实战](https://github.com/phodal/growth-in-action)》效果最佳。

> 依据在《[Repractise简介篇：Web开发的七天里](http://mp.weixin.qq.com/s?__biz=MjM5Mjg4NDMwMA==&mid=403171959&idx=1&sn=08f0717e2306efd7d80c8bb603e644d0#rd)》中所说的 Web 开发的七个步骤而展开的电子书。当然它也是一个 APP，它是一本关于如何成为全栈增长工程师的指南。

简介
--

**这是一本指导性的书籍——不要指望从这本书中学到所有的知识点，但是它可以帮你构建你的知识体系。**
我们都会学习，但是有时候我们只是不知道应该学习什么而已。
**这也是其他技术书籍所欠缺的。它可以告诉你，你可以学习什么，然后看什么书。**

对于有些人来说，成为全栈是因为：**来自社会的各个不同的中小公司，只靠一个领域的知识难以生存**
对于有些人来说，成为全栈是因为：**这个世界有太多的乐趣，在一颗树上吊死太可惜了**。
对于有些人来说，成为全栈是因为：**他们想去创业**。

而人们对于全栈有太多的误解——**认为全栈应该什么都会，什么都精通**。全栈只是因为我们对系统有整体性的认识，而不是精通整个系统。因为专家只精通某一个领域，总得有一个**架构师**来对系统把握。

我更愿意去改称这本书为《增长工程师指南》，去避免对这本书的误解。但是我想要去改变人们的观点，全栈更侧重于知识体系的增长。因为人们对于专家还有一个印象：古板。

我的其他电子书：

 - 《[一步步搭建物联网系统](https://github.com/phodal/designiot)》
 - 《[GitHub 漫游指南](https://github.com/phodal/github-roam)》
 - 《[RePractise](https://github.com/phodal/repractise)》

在线预览：[http://growth.phodal.com/](http://growth.phodal.com/)

**下载**: 

GitHub直接下载：[Epub版](https://github.com/phodal/growth-ebook/releases/download/0.9.9/growth.epub)、[Mobi版](https://github.com/phodal/growth-ebook/releases/download/0.9.9/growth.mobi)、[PDF版](https://github.com/phodal/growth-ebook/releases/download/0.9.9/growth.pdf)、[RTF版](https://github.com/phodal/growth-ebook/releases/download/0.9.9/growth.rtf)

百度盘：http://pan.baidu.com/s/1qYuy5Bm

没钱捧个人场: 关注我的微信公众号（扫描下面的二维码或搜索 Phodal）.

![QRCode](./marketing/wp.jpg)

有钱捧个钱场:

![Alipay](./marketing/alipay.png)![Wechat](./marketing/wechat.png)


应用下载
---

<a href="https://play.google.com/store/apps/details?id=ren.growth&utm_source=global_co&utm_medium=prtnr&utm_content=Mar2515&utm_campaign=PartBadge&pcampaignid=MKT-AC-global-none-all-co-pr-py-PartBadges-Oct1515-1"><img alt="Get it on Google Play" src="https://play.google.com/intl/en_us/badges/images/apps/en-play-badge-border.png" width="180"/></a>
<a href="http://windowsphone.com/s?appid=a6022e5d-b101-4d8f-a836-d3bfb6fd73ef"><img src="https://assets.windowsphone.com/8d997df3-5b6e-496c-88b3-e3f40117c8fd/English-get-it-from-MS_InvariantCulture_Default.png" srcset="https://assets.windowsphone.com/0100c7e5-1455-40bc-a351-b77d2801ad5a/English_get-it-from-MS_InvariantCulture_Default.png 2x"  alt="Get it from Microsoft" /></a>
<a href="https://itunes.apple.com/cn/app/growth/id1078807522?l=zh&ls=1&mt=8"><img src="https://raw.githubusercontent.com/phodal/growth/master/docs/apple.png" width="180" alt="Get it from Apple Store" /></a>

目录
---

*   [Growth: 全栈增长工程师指南](http://growth.phodal.com/#growth-全栈增长工程师指南)
    *   [全栈工程师是未来](http://growth.phodal.com/#全栈工程师是未来)
        *   [技术的革新史](http://growth.phodal.com/#技术的革新史)
        *   [软件开发的核心难题：沟通](http://growth.phodal.com/#软件开发的核心难题沟通)
        *   [大公司的专家与小公司的全栈](http://growth.phodal.com/#大公司的专家与小公司的全栈)
        *   [全栈工程师的未来：无栈](http://growth.phodal.com/#全栈工程师的未来无栈)
*   [基础知识篇](http://growth.phodal.com/#基础知识篇)
    *   [工具只是辅助](http://growth.phodal.com/#工具只是辅助)
        *   [WebStorm 还是 Sublime?](http://growth.phodal.com/#webstorm-还是-sublime)
        *   [语言也是一种工具](http://growth.phodal.com/#语言也是一种工具)
    *   [提高效率的工具](http://growth.phodal.com/#提高效率的工具)
        *   [快速启动软件](http://growth.phodal.com/#快速启动软件)
        *   [IDE](http://growth.phodal.com/#ide)
        *   [DEBUG 工具](http://growth.phodal.com/#debug-工具)
        *   [终端或命令提示符](http://growth.phodal.com/#终端或命令提示符)
        *   [包管理](http://growth.phodal.com/#包管理)
    *   [环境搭建](http://growth.phodal.com/#环境搭建)
        *   [OS X](http://growth.phodal.com/#os-x)
        *   [Windows](http://growth.phodal.com/#windows)
        *   [GNU/Linux](http://growth.phodal.com/#gnulinux)
    *   [学好一门语言的艺术](http://growth.phodal.com/#学好一门语言的艺术)
        *   [一次语言学习体验](http://growth.phodal.com/#一次语言学习体验)
        *   [输出是最好的输入](http://growth.phodal.com/#输出是最好的输入)
        *   [如何应用一门新的技术](http://growth.phodal.com/#如何应用一门新的技术)
    *   [Web 编程基础](http://growth.phodal.com/#web-编程基础)
        *   [从浏览器到服务器](http://growth.phodal.com/#从浏览器到服务器)
        *   [从 HTML 到页面显示](http://growth.phodal.com/#从-html-到页面显示)
    *   [HTML](http://growth.phodal.com/#html)
        *   [hello,world](http://growth.phodal.com/#helloworld)
        *   [中文？](http://growth.phodal.com/#中文)
        *   [其他 HTML 标记](http://growth.phodal.com/#其他-html-标记)
        *   [小结](http://growth.phodal.com/#小结-1)
    *   [CSS](http://growth.phodal.com/#css)
        *   [简介](http://growth.phodal.com/#简介)
        *   [样式与目标](http://growth.phodal.com/#样式与目标)
        *   [选择器](http://growth.phodal.com/#选择器)
        *   [更有趣的 CSS](http://growth.phodal.com/#更有趣的-css)
    *   [JavaScript](http://growth.phodal.com/#javascript)
        *   [hello,world](http://growth.phodal.com/#helloworld-1)
        *   [JavaScriptFul](http://growth.phodal.com/#javascriptful)
        *   [面向对象](http://growth.phodal.com/#面向对象)
        *   [其他](http://growth.phodal.com/#其他)
*   [前端与后台](http://growth.phodal.com/#前端与后台)
    *   [后台语言选择](http://growth.phodal.com/#后台语言选择)
        *   [JavaScript](http://growth.phodal.com/#javascript-1)
        *   [Python](http://growth.phodal.com/#python)
        *   [Java](http://growth.phodal.com/#java)
        *   [PHP](http://growth.phodal.com/#php)
        *   [其他](http://growth.phodal.com/#其他-1)
    *   [MVC](http://growth.phodal.com/#mvc)
        *   [Model](http://growth.phodal.com/#model)
        *   [View](http://growth.phodal.com/#view)
        *   [Controller](http://growth.phodal.com/#controller)
        *   [更多](http://growth.phodal.com/#更多-1)
    *   [后台即服务](http://growth.phodal.com/#后台即服务)
        *   [API 演进史](http://growth.phodal.com/#api-演进史)
        *   [后台即服务](http://growth.phodal.com/#后台即服务-1)
    *   [数据持久化](http://growth.phodal.com/#数据持久化)
        *   [文件存储](http://growth.phodal.com/#文件存储)
        *   [数据库](http://growth.phodal.com/#数据库)
        *   [搜索引擎](http://growth.phodal.com/#搜索引擎)
    *   [前端框架选择](http://growth.phodal.com/#前端框架选择)
        *   [Angular](http://growth.phodal.com/#angular)
        *   [React](http://growth.phodal.com/#react)
        *   [Vue](http://growth.phodal.com/#vue)
        *   [jQuery 系](http://growth.phodal.com/#jquery-系)
    *   [前台与后台交互](http://growth.phodal.com/#前台与后台交互)
        *   [Ajax](http://growth.phodal.com/#ajax)
        *   [JSON](http://growth.phodal.com/#json)
        *   [WebSocket](http://growth.phodal.com/#websocket)
*   [编码](http://growth.phodal.com/#编码)
    *   [编码过程](http://growth.phodal.com/#编码过程)
    *   [Web 应用的构建系统](http://growth.phodal.com/#web-应用的构建系统)
        *   [Web 应用的构建过程](http://growth.phodal.com/#web-应用的构建过程)
        *   [Web 应用的构建实战](http://growth.phodal.com/#web-应用的构建实战)
    *   [Git 与版本控制](http://growth.phodal.com/#git-与版本控制)
        *   [版本控制](http://growth.phodal.com/#版本控制)
        *   [Git](http://growth.phodal.com/#git)
    *   [Tasking](http://growth.phodal.com/#tasking)
        *   [如何 Tasking 一本书](http://growth.phodal.com/#如何-tasking-一本书)
        *   [Tasking 开发任务](http://growth.phodal.com/#tasking-开发任务)
    *   [写代码只是在码字](http://growth.phodal.com/#写代码只是在码字)
    *   [内置索引与外置引擎](http://growth.phodal.com/#内置索引与外置引擎)
        *   [门户网站](http://growth.phodal.com/#门户网站)
        *   [内置索引与外置引擎](http://growth.phodal.com/#内置索引与外置引擎-1)
    *   [如何编写测试](http://growth.phodal.com/#如何编写测试)
        *   [测试金字塔](http://growth.phodal.com/#测试金字塔)
        *   [如何测试](http://growth.phodal.com/#如何测试)
    *   [测试替身](http://growth.phodal.com/#测试替身)
        *   [Stub](http://growth.phodal.com/#stub)
        *   [Mock](http://growth.phodal.com/#mock)
    *   [测试驱动开发](http://growth.phodal.com/#测试驱动开发)
        *   [红-绿-重构](http://growth.phodal.com/#红-绿-重构)
        *   [测试先行](http://growth.phodal.com/#测试先行)
    *   [可读的代码](http://growth.phodal.com/#可读的代码)
        *   [命名](http://growth.phodal.com/#命名)
        *   [函数长度](http://growth.phodal.com/#函数长度)
        *   [其他](http://growth.phodal.com/#其他-2)
    *   [代码重构](http://growth.phodal.com/#代码重构)
        *   [重命名](http://growth.phodal.com/#重命名)
        *   [提取变量](http://growth.phodal.com/#提取变量)
        *   [提炼函数](http://growth.phodal.com/#提炼函数)
    *   [Intellij Idea 重构](http://growth.phodal.com/#intellij-idea-重构)
        *   [提炼函数](http://growth.phodal.com/#提炼函数-1)
        *   [内联函数](http://growth.phodal.com/#内联函数)
        *   [查询取代临时变量](http://growth.phodal.com/#查询取代临时变量)
    *   [重构到设计模式](http://growth.phodal.com/#重构到设计模式)
        *   [过度设计与设计模式](http://growth.phodal.com/#过度设计与设计模式)
*   [上线](http://growth.phodal.com/#上线)
    *   [隔离与运行环境](http://growth.phodal.com/#隔离与运行环境)
        *   [隔离硬件：虚拟机](http://growth.phodal.com/#隔离硬件虚拟机)
        *   [隔离操作系统：容器虚拟化](http://growth.phodal.com/#隔离操作系统容器虚拟化)
        *   [隔离底层：Servlet 容器](http://growth.phodal.com/#隔离底层servlet-容器)
        *   [隔离依赖版本：虚拟环境](http://growth.phodal.com/#隔离依赖版本虚拟环境)
        *   [隔离运行环境：语言虚拟机](http://growth.phodal.com/#隔离运行环境语言虚拟机)
        *   [隔离语言：DSL](http://growth.phodal.com/#隔离语言dsl)
    *   [LNMP 架构](http://growth.phodal.com/#lnmp-架构)
        *   [GNU/Linux](http://growth.phodal.com/#gnulinux-1)
        *   [HTTP 服务器](http://growth.phodal.com/#http-服务器)
    *   [Web 缓存](http://growth.phodal.com/#web-缓存)
        *   [数据库端缓存](http://growth.phodal.com/#数据库端缓存)
        *   [应用层缓存](http://growth.phodal.com/#应用层缓存)
        *   [前端缓存](http://growth.phodal.com/#前端缓存)
        *   [客户端缓存](http://growth.phodal.com/#客户端缓存)
        *   [HTML5 离线缓存](http://growth.phodal.com/#html5-离线缓存)
    *   [可配置](http://growth.phodal.com/#可配置)
        *   [环境配置](http://growth.phodal.com/#环境配置)
        *   [运行机制](http://growth.phodal.com/#运行机制)
        *   [功能开关](http://growth.phodal.com/#功能开关)
    *   [自动化部署](http://growth.phodal.com/#自动化部署)
        *   [依赖与包仓库](http://growth.phodal.com/#依赖与包仓库)
        *   [构建软件包](http://growth.phodal.com/#构建软件包)
        *   [上传和安装软件包](http://growth.phodal.com/#上传和安装软件包)
*   [数据分析](http://growth.phodal.com/#数据分析)
    *   [构建-衡量-学习](http://growth.phodal.com/#构建-衡量-学习)
        *   [想法-构建](http://growth.phodal.com/#想法-构建)
        *   [产品-衡量](http://growth.phodal.com/#产品-衡量)
        *   [数据-学习](http://growth.phodal.com/#数据-学习)
    *   [数据分析](http://growth.phodal.com/#数据分析-1)
        *   [识别需求](http://growth.phodal.com/#识别需求)
        *   [收集数据](http://growth.phodal.com/#收集数据)
        *   [分析数据](http://growth.phodal.com/#分析数据)
        *   [展示数据](http://growth.phodal.com/#展示数据)
    *   [用户数据分析：Google Analytics](http://growth.phodal.com/#用户数据分析google-analytics)
        *   [受众群体](http://growth.phodal.com/#受众群体)
        *   [流量获取](http://growth.phodal.com/#流量获取)
        *   [移动应用](http://growth.phodal.com/#移动应用)
    *   [网站性能](http://growth.phodal.com/#网站性能)
        *   [网站性能监测](http://growth.phodal.com/#网站性能监测)
        *   [网站性能](http://growth.phodal.com/#网站性能-1)
    *   [SEO](http://growth.phodal.com/#seo)
        *   [爬虫与索引](http://growth.phodal.com/#爬虫与索引)
        *   [什么样的网站需要 SEO？](http://growth.phodal.com/#什么样的网站需要-seo)
        *   [SEO 基础知识](http://growth.phodal.com/#seo-基础知识)
        *   [内容](http://growth.phodal.com/#内容)
    *   [UX 入门](http://growth.phodal.com/#ux-入门)
        *   [什么是 UX](http://growth.phodal.com/#什么是-ux)
        *   [什么是简单？](http://growth.phodal.com/#什么是简单)
        *   [进阶](http://growth.phodal.com/#进阶)
        *   [用户体验要素](http://growth.phodal.com/#用户体验要素)
    *   [认知设计](http://growth.phodal.com/#认知设计)
        *   [流](http://growth.phodal.com/#流)
*   [持续交付](http://growth.phodal.com/#持续交付)
    *   [持续集成](http://growth.phodal.com/#持续集成)
        *   [持续集成系统](http://growth.phodal.com/#持续集成系统)
        *   [持续集成流程](http://growth.phodal.com/#持续集成流程)
    *   [持续交付](http://growth.phodal.com/#持续交付-1)
        *   [基础设施](http://growth.phodal.com/#基础设施)
        *   [持续部署](http://growth.phodal.com/#持续部署)
    *   [持续学习](http://growth.phodal.com/#持续学习)
        *   [持续阅读](http://growth.phodal.com/#持续阅读)
        *   [持续编程](http://growth.phodal.com/#持续编程)
        *   [持续写作](http://growth.phodal.com/#持续写作)
*   [遗留系统与修改代码](http://growth.phodal.com/#遗留系统与修改代码)
    *   [遗留代码](http://growth.phodal.com/#遗留代码)
        *   [遗留代码](http://growth.phodal.com/#遗留代码-1)
    *   [如何修改遗留代码](http://growth.phodal.com/#如何修改遗留代码)
        *   [修改遗留代码](http://growth.phodal.com/#修改遗留代码)
    *   [网站重构](http://growth.phodal.com/#网站重构)
        *   [速度优化](http://growth.phodal.com/#速度优化)
        *   [功能加强](http://growth.phodal.com/#功能加强)
        *   [模块重构](http://growth.phodal.com/#模块重构)
*   [回顾与架构设计](http://growth.phodal.com/#回顾与架构设计)
    *   [自我总结](http://growth.phodal.com/#自我总结)
        *   [吾日三省吾身](http://growth.phodal.com/#吾日三省吾身)
    *   [Retro](http://growth.phodal.com/#retro)
        *   [Retro 的过程](http://growth.phodal.com/#retro-的过程)
        *   [三个维度](http://growth.phodal.com/#三个维度)
    *   [架构模式](http://growth.phodal.com/#架构模式)
        *   [预设计式架构](http://growth.phodal.com/#预设计式架构)
        *   [演进式架构：拥抱变化](http://growth.phodal.com/#演进式架构拥抱变化)
    *   [浮现式设计](http://growth.phodal.com/#浮现式设计)
        *   [意图导向](http://growth.phodal.com/#意图导向)
        *   [重构](http://growth.phodal.com/#重构)
        *   [模式与演进](http://growth.phodal.com/#模式与演进)
    *   [每个人都是架构师](http://growth.phodal.com/#每个人都是架构师)
        *   [如何构建一个博客系统](http://growth.phodal.com/#如何构建一个博客系统)
        *   [相关阅读资料](http://growth.phodal.com/#相关阅读资料)
    *   [架构解耦](http://growth.phodal.com/#架构解耦)
        *   [从 MVC 与微服务](http://growth.phodal.com/#从-mvc-与微服务)
        *   [CQRS](http://growth.phodal.com/#cqrs)
        *   [CQRS 结合微服务](http://growth.phodal.com/#cqrs-结合微服务)

Contributors
---

 - [aidewoode](https://github.com/aidewoode)
 - [Evan Lau](https://github.com/lolosssss)
 - [loveisbug](https://github.com/loveisbug)
 - [wangcongyi](https://github.com/wangcongyi)
 - [wangyufeng0615](https://github.com/wangyufeng0615)

License
---

[![Phodal's Article](http://brand.phodal.com/shields/article-small.svg)](https://www.phodal.com/) [![Phodal's Book](http://brand.phodal.com/shields/book-small.svg)](https://www.phodal.com/)


© 2015~2016 [Phodal Huang](https://www.phodal.com). This code is distributed under the Creative Commons Attribution-Noncommercial-No Derivative Works 3.0  License. See `LICENSE` in this directory.

[待我代码编成，娶你为妻可好](http://www.xuntayizhan.com/blog/ji-ke-ai-qing-zhi-er-shi-dai-wo-dai-ma-bian-cheng-qu-ni-wei-qi-ke-hao-wan/)
