构建-衡量-学习
---

构建-衡量-学习是在《精益创业》中的一个核心概念，这结合了客户开发、敏捷软件开发方法和精益生产实践。它们是非常重要的一个循环：

![数据分析过程](assets/article/chapter5/lean-analytics.png)

这一过程不仅可以改进我们的产品，也可以用于初创企业。它并不是独立的一个环节，实现上它应该是一整个环节：我们根据我们的想法去创建产品，在使用产品的过程中收集一些数据，再依据这些数据来改进我们的产品。

###想法-构建

想法实际上便是解决一个痛点的解决方案。如果你和我一样也经常记录自己的想法，就会发现每个月里，你总会跳出一个又一个的想法。正如，我在那篇《[如何去管理你的 Idea](https://www.phodal.com/blog/use-github-manage-idea/)》中说的一样：

> 我们经常说的是我们缺少一个 Idea。过去我也一直觉得我缺少一些 Idea，今天发现并非如此，我们只是缺少记录的手段。

我们并不缺少 Idea，只是一直没有去记录。随着时间的增长，我发现我的 GitHub 上的 Idea 墙([ideas](https://github.com/phodal/ideas/issues))一直在不断地增加。以至于，我有一个新的 Idea 就是整理这个 Idea 墙。

而作为一个程序员，我们本身就可以具备构建一个系统的能力，只是对于大多数人来说需要多加的练习。有意思的一点是，这里的构建系统与一般的构建系统有一点不太一样，我们需要快速地构建出一个 MVP 产品。MVP 简单地来说，就是最小可用的产品。如下图的右边所示：

![MVP](assets/article/chapter5/mvp.png)

在每一层级上都实现一定的功能，使得这个系统可用，而非构建一个非常完整的系统。随后，我们就可以寻找一些种子用户来改进我们的产品。

###产品-衡量

按照上面的步骤，到了这里应该就是客户开发。而如《精益客开发》一书所说，客户开发可以分成五个步骤：

 - 形成假设。即我们觉得用
 - 找到可以交谈的潜在客户
 - 提出恰当的问题
 - 从答案中找到有用的信息
 - 弄明白现阶段需要构建什么样的产品来保持下一个学习循环

在整个过程中，我们其实就是在了解我们的客户是谁，以及他们的需求。并且在这个过程中，我们可以为开发确认出清晰的假设，一点点地打造出用户喜爱的产品。

###数据-学习

当我们收集到一定的用户数据，如网站、应用的数据，就可以开始分析数据。如《精益创业》所说，在分析数据之前，我们需要确定我们的增长模型，即：

 - 黏着式增长引擎——其重点是让用户成为回头客，即让客户持续使用我们的产品。这就意味着，我们在分析数据和学习的过程中，要侧重于关注流失率和使用频率。
 - 病毒式增长引擎——其只做一件事：让名声传播出去。即通过用户间的不断传播来扩散产品，我们需要考虑所谓的**病毒式传播系数**，还有用户之间的特定行为。
 - 付费式增长引擎——赚钱与否是识别商业模式是否可持续的指标。

 针对不同的增长引擎有不同的学习过程，如媒体网站，我们通过不同的方式来导入流量，这些流量最终会有一些会转化成价值。这些价值会以不同的形式出现，如订阅率、在线参与度、广告营收等等。

 而从这些数据中学习就需要一些特殊的技巧，详情请见下面的参考书籍。

 参考书籍：

  - 《精益数据分析》
  - 《精益客户开发》
  - 《精益创业》
