用户数据分析：Google Analytics
---

Google Analytics 是一个非常赞的分析工具，它不仅可以用于 Web 应用，也可以用于移动应用。

###受众群体

如下图是 Growth 应用最近两星期的数据：

![Growth GA](assets/article/chapter5/growth-ga.png)

这是 Google Analytics 中的“受众群体”的概览，在这个视图中：

1. 折线图就是每天的用户数。
2. 下面会有用户数、会话、屏幕浏览量等等的一些信息。
3. 右角的饼图则是回访问用户和新用户的对比。
4. 最下方便是受众的信息——国家、版本等等。

从图中，我们可以读取一些重要的信息，如用户的停留时间、主要面向的用户等等。在浏览器版本会有：

1. 浏览器与操作系统
2. 移动设备

这样的重要数据，如下表是我网站 20160104-20160120 的访问数据：

浏览器|会话|新会话百分比
-----|----|----
Chrome|5048|75.99%
Firefox|694|78.39%
Safari|666|78.68%
Internet Explorer|284|87.68%
Safari (in-app)|92|86.96%
Android Browser|72|87.50%
Edge|63|79.37%
Maxthon|51|68.63%
UC Browser|41|80.49%
Opera|34|64.71%

可以从上表中看到访问我网站的用户中，IE 只占很小的一部分——大概4%，而 Chrome + Safari + Firefox 加起来则近90%。这也意味着，我可以完全不考虑 IE 用户的感受。

类似于这样的数据在我们决定对某个浏览器的支持情况时是非常有帮助的。也会加快开发，我们可以工作于主要的浏览器上。

###流量获取

除此，不得不说的一点就是流量获取，如下图所示是我博客的热门渠道：

![Phodal.com Traffic](assets/article/chapter5/phodal-traffic.png)

可以直接得到一个不错的结论是我的博客的主要流量来源是搜索引擎，再细细一看数据：

来源/媒介 | 会话
----------|---------
baidu / organic | 2031
google / organic | 1314
(direct) / (none) | 1311
bing / organic | 349
github.com / referral | 281

主要流量来源就是 Baidu 和 Google，看来国人还是用百度比较多。那我们就可以针对 SEO 进行更多的优化：

1. 加快访问速度
2. 更表意的 URL
3. 更好的标题
4. 更好的内容

等等等。

除此，我们可以分析用户的行为，如他们访问的主要网站、URL 等等。

###移动应用

除此，我们还可以使用它来分析移动应用，不过这受限于 Google 在国内的访问程度。如下图是 GA 收到的应用的使用数据：

![Growth 应用数据](assets/article/chapter5/ga-app.jpg)

我们也可以从上面看到 APP 的安装来源等等。
