UX 入门
---

用户体验设计（英语：User Experience Design），是以用户为中心的一种设计手段，以用户需求为目标而进行的设计。设计过程注重以用户为中心，用户体验的概念从开发的最早期就开始进入整个流程，并贯穿始终。其目的就是保证：

- 对用户体验有正确的预估
- 认识用户的真实期望和目的
- 在核心功能还能够以低廉成本加以修改的时候对设计进行修正
- 保证核心功能同人机界面之间的协调工作，减少 BUG。

关于 UX 的定义我觉得在知乎上的回答似乎太简单了，于是在网上寻寻觅觅终于找到了一个比较接近于答案的回答。原文是在: [Defining UX](http://deviseconsulting.com/defining-ux/)，这又是一篇不是翻译的翻译。

###什么是 UX

用户体验设计（英语：User Experience Design），是以用户为中心的一种设计手段，以用户需求为目标而进行的设计。设计过程注重以用户为中心，用户体验的概念从开发的最早期就开始进入整个流程，并贯穿始终。其目的就是保证：

 - 对用户体验有正确的预估
 - 认识用户的真实期望和目的
 - 在核心功能还能够以低廉成本加以修改的时候对设计进行修正
 - 保证核心功能同人机界面之间的协调工作，减少BUG。

**UX 需要什么**

从下图中我们可以看到一些 UX 所需要的知识体系：

![UX](assets/article/chapter5/ux_design.jpg)

即

 - 信息构架
 - 构架
 - 工业设计
 - 人为因素  (人因学)
 - 声音设计 (网页设计中比较少)
 - 人机交互
 - 可视化设计
 - 内容 (文字,视频,声音)

交互设计便是``用户体验设计的重点``。我们再来看看另外的这张图片

![Fields Of User Experience Design](assets/article/chapter5/ux-field.jpg)

###什么是简单？

一个好的软件应该是简单的，并且是令人愉快的。

在不同的 UX 书籍里，似乎就会说到【简约至上】。简单就是“单纯清楚、不复杂”。而这里的简单并不仅仅只是不复杂那么简单。对于一个软件来说，简单实际上是你一下子就能找到你想要的东西，如：

![Search Phodal](assets/article/chapter5/search-phodal.jpg)

而我们并不可能在一开始就得到这样的结果，这需要一个复杂的过程。而在这个过程开始之前，我们一定要知道的一点是：我们的用户到底需要什么?

如果我们无法知道这一点，而只是一直在假想客户需要什么，那么这会变成一条死路。

接着在找寻的过程中，发现了一个有意思的图，即精益画布：

![Lean](assets/article/chapter5/lean.jpg)

首先，我们需要知道几个用户而存在的问题——即客户最需要解决的三个问题。并且针对三个问题提出对应的解决方案，这也就是产品的主要功能。

那么，这两点结合起来对于用户来说就是简单——这个软件能解决客户存在的主要问题。

如果我们可以完成这部分功能的话，那么这就算得上是一个有用的软件。

###进阶

而实际上“实用”则是位于用户体验的最底层，如下图所示：

![UX](assets/article/chapter5/layer.jpg)

这时候就需要尽量往可用靠拢。怎样对两者进行一个简单的划分？

下图就是实用的软件：

![IE Alert](assets/article/chapter5/ie-alert.jpg)

而下图就便好一点了：

![jQuery Popup](assets/article/chapter5/popup.jpg)

要达到可用的级别，并不是一件困难的事：**遵循现有软件的模式**。

换句话说，这时候你需要的是一本 **Cookbook**。这本 **Cookbook** 上面就会列出诸多现有的设计模式，只需要参考便使用就差不多了。

同样的，我便尝试用《移动应用 UI 设计模式》一本书对我原有的软件进行了一些设计，发现它真的可以达到这样的地步。

而这也类似于在编程中的设计模式，遵循模式可以创造出不错的软件。

###用户体验要素

尽管对于这方面没有非常好的认识，但是还是让我们来看看我们现在可以到哪种程度。如在一开始所说的，我们需要满足用户的需求，这就是我们的目标：

![用户体验要素](assets/article/chapter5/ux-elements.png)

而在最上面的视觉设计则需要更专业的人来设计。

**参考目录**

 - 《怦然心动——情感化设计交互指南》
 - 《用户体验要素》
 - 《移动应用UI设计模式》
